
#
# A simple class to demonstrate Python class basics
#
# author: David Mathias
#

class Account():

    # a class variable -- shared by all instances
    num_accounts = 0
    
    # create instance variables and initialize values
    def __init__(self, name, balance):
        print('In Account __init__')
        self.name = name
        self.balance = balance
        Account.num_accounts += 1
    
    # do this when reference count for an instance reaches 0
    def __del__(self):
        Account.num_accounts -= 1
        
    def __hash__(self):
        return hash((self.name, self.balance))

    def __eq__(self, other):
        return (self.name, self.balane) == (other.name, other.balance)
    
    def __str__(self):
        return('{}\n{}\n'.format(self.name, self.balance))
    
    # these are the instance methods
    def deposit(self, amt):
        print('In Account deposit')
        self.balance += amt
        
    def withdraw(self, amt):
        print('In Account withdraw')
        self.balance -= amt
        
    def inquiry(self):
        print('In Account inquiry')
        return self.balance
    
